#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <richedit.h>
#include <commctrl.h>
#include <shellapi.h>
#include <shlobj.h>
#include "AkelDLL.h"
#include "Resources\Resource.h"


//Defines
#define DLLA_EXPLORER_GOTOPATH  1
#define DLLA_EXPLORER_REFRESH   2

#define STRID_SETUP         1
#define STRID_FINDDOCUMENT  2
#define STRID_REFRESH       3
#define STRID_ROOTDIRECTORY 4
#define STRID_MYCOMPUTER    5
#define STRID_SHOWHIDDEN    6
#define STRID_OK            7
#define STRID_CANCEL        8

#define AKDLL_INIT          (WM_USER + 1)
#define AKDLL_SETUP         (WM_USER + 2)
#define AKDLL_FINDDOCUMENT  (WM_USER + 3)
#define AKDLL_REFRESH       (WM_USER + 4)

#define OF_WINDOWRECT     0x1
#define OF_SETTINGS       0x2

//DestroyDock type
#define DKT_UNLOAD         0
#define DKT_NOUNLOAD       1
#define DKT_ONMAINFINISH   2

#ifndef SFGAO_STREAM
  #define SFGAO_STREAM 0x00400000
#endif

typedef struct tagID {
  LPSHELLFOLDER psfParent;
  LPITEMIDLIST pidlRoot;
  LPITEMIDLIST pidlItem;
} TVITEMDATA, *LPTVITEMDATA;

typedef struct _PMOPENDOCUMENTA {
  POSTMESSAGE pm;
  OPENDOCUMENTA od;
  COPYDATASTRUCT cds;
} PMOPENDOCUMENTA;

typedef struct _PMOPENDOCUMENTW {
  POSTMESSAGE pm;
  OPENDOCUMENTW od;
  COPYDATASTRUCT cds;
} PMOPENDOCUMENTW;

#ifndef _INC_COMMCTRL
  typedef struct tagTVKEYDOWN {
    NMHDR hdr;
    WORD wVKey;
    UINT flags;
  } NMTVKEYDOWN, FAR *LPNMTVKEYDOWN;
#endif

//DIALOGRESIZE
#define DRS_SIZE  0x1 //Resize control
#define DRS_MOVE  0x2 //Move control
#define DRS_X     0x4 //X value
#define DRS_Y     0x8 //Y value

typedef struct {
  HWND *lpWnd;   //Control window
  DWORD dwType;  //See DRS_* defines
} DIALOGRESIZE;

//Functions prototypes
void CreateDock(HWND *hWndDock, DOCK **dkDock);
void DestroyDock(HWND hWndDock, DWORD dwType);
BOOL CALLBACK MainDlgProcA(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK MainDlgProcW(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL DialogResizeMessages(DIALOGRESIZE *drs, RECT *rcInit, RECT *rcCurrent, HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL GetWindowPos(HWND hWnd, HWND hWndOwner, RECT *rc);
BOOL CALLBACK SetupDlgProcA(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK SetupDlgProcW(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK NewMainProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
void PopulateTreeA(HWND hWnd, int nRootSpecial, char *pRootDirectory);
void PopulateTreeW(HWND hWnd, int nRootSpecial, wchar_t *wpRootDirectory);
void FillTreeViewA(HWND hWnd, LPSHELLFOLDER psfRoot, LPITEMIDLIST pidlRoot, HTREEITEM hParent);
void FillTreeViewW(HWND hWnd, LPSHELLFOLDER psfRoot, LPITEMIDLIST pidlRoot, HTREEITEM hParent);
void SearchTreeViewA(HWND hWnd, char *pPath);
void SearchTreeViewW(HWND hWnd, wchar_t *wpPath);
HTREEITEM GetSelItemTreeViewA(HWND hWnd, char *szPath);
HTREEITEM GetSelItemTreeViewW(HWND hWnd, wchar_t *wszPath);
int CALLBACK TreeViewCompareProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);
BOOL GetItemNameA(LPSHELLFOLDER psf, LPITEMIDLIST pidl, DWORD dwFlags, char *szName, int nMaxName);
BOOL GetItemNameW(LPSHELLFOLDER psf, LPITEMIDLIST pidl, DWORD dwFlags, wchar_t *wszName, int nMaxName);
int GetItemIconA(LPITEMIDLIST pidl, UINT uFlags);
int GetItemIconW(LPITEMIDLIST pidl, UINT uFlags);
LPITEMIDLIST CreatePIDL(UINT cbSize);
LPITEMIDLIST NextPIDL(LPCITEMIDLIST pidl);
UINT GetSizePIDL(LPCITEMIDLIST pidl);
LPITEMIDLIST CopyPIDL(LPCITEMIDLIST pidl);
LPITEMIDLIST ConcatPIDL(LPCITEMIDLIST pidl1, LPCITEMIDLIST pidl2);
BOOL CompareITEMID(LPCITEMIDLIST pidl1, LPCITEMIDLIST pidl2);
LPITEMIDLIST ComparePIDL(LPCITEMIDLIST pidlFull, LPCITEMIDLIST pidlPart);
void OpenDocumentA(char *pFile);
void OpenDocumentW(wchar_t *wpFile);
BOOL IsDirEmptyA(char *pDir);
BOOL IsDirEmptyW(wchar_t *wpDir);
BOOL TrimTrailBackSlashA(char *szDir);
BOOL TrimTrailBackSlashW(wchar_t *wszDir);
void ReadOptionsA();
void ReadOptionsW();
void SaveOptionsA(DWORD dwFlags);
void SaveOptionsW(DWORD dwFlags);
char* GetLangStringA(LANGID wLangID, int nStringID);
wchar_t* GetLangStringW(LANGID wLangID, int nStringID);
BOOL IsExtCallParamValid(LPARAM lParam, int nIndex);
int GetExtCallParam(LPARAM lParam, int nIndex);
void InitCommon(PLUGINDATA *pd);
void InitMain();
void UninitMain();

//GetProcAddress
int (WINAPI *SHFileOperationAPtr)(LPSHFILEOPSTRUCTA);
int (WINAPI *SHFileOperationWPtr)(LPSHFILEOPSTRUCTW);
DWORD (WINAPI *SHGetFileInfoAPtr)(char *, DWORD, SHFILEINFOA *, UINT, UINT);
DWORD (WINAPI *SHGetFileInfoWPtr)(wchar_t *, DWORD, SHFILEINFOW *, UINT, UINT);
BOOL (WINAPI *SHGetPathFromIDListAPrt)(LPCITEMIDLIST, char *);
BOOL (WINAPI *SHGetPathFromIDListWPrt)(LPCITEMIDLIST, wchar_t *);

//Global variables
char szPluginName[MAX_PATH];
wchar_t wszPluginName[MAX_PATH];
HINSTANCE hInstanceDLL;
HWND hMainWnd;
HWND hWndEdit;
BOOL bMDI;
BOOL bOldWindows;
LANGID wLangSystem;
BOOL bInitCommon=FALSE;
BOOL bInitMain=FALSE;
HWND hWndMainDlg=NULL;
HWND hWndBrowseTree=NULL;
HMENU hMenuLabel=NULL;
RECT rcMainInitDialog={0};
RECT rcMainCurrentDialog={0};
RECT rcDockRect={0};
int nDockSide=DKS_LEFT;
DOCK *dkMainDlg=NULL;
char szRootDirectory[MAX_PATH]="";
wchar_t wszRootDirectory[MAX_PATH]=L"";
int nRootSpecial=CSIDL_DESKTOP;
BOOL bShowHidden=FALSE;
BOOL bOnMainStart=FALSE;
BOOL bDockWaitResize=FALSE;
BOOL bMainDialogRectSave=FALSE;
WNDPROCDATA *NewMainProcData=NULL;
WNDPROCDATA *NewFrameProcData=NULL;


//Identification
extern "C" void __declspec(dllexport) DllAkelPadID(PLUGINVERSION *pv)
{
  pv->dwAkelDllVersion=AKELDLL;
  pv->dwExeMinVersion3x=MAKE_IDENTIFIER(3, 7, 4, 0);
  pv->dwExeMinVersion4x=MAKE_IDENTIFIER(4, 4, 0, 0);
  pv->pPluginName="Explorer";
}

//Plugin extern functions
extern "C" void __declspec(dllexport) Main(PLUGINDATA *pd)
{
  if (pd->lpbAutoLoad)
  {
    *pd->lpbAutoLoad=TRUE;
    return;
  }

  if (!bInitCommon) InitCommon(pd);

  if (bInitMain)
  {
    if (!pd->lParam)
    {
      if (hWndMainDlg) DestroyDock(hWndMainDlg, DKT_UNLOAD);

      //Stay in memory, but show as non-active
      pd->nUnload=UD_NONUNLOAD_NONACTIVE;
    }
  }
  else
  {
    InitMain();

    bDockWaitResize=pd->bOnStart;
    CreateDock(&hWndMainDlg, &dkMainDlg);

    //Stay in memory, and show as active
    pd->nUnload=UD_NONUNLOAD_ACTIVE;
  }

  if (pd->lParam)
  {
    if (IsExtCallParamValid(pd->lParam, 1))
    {
      if (bOldWindows)
      {
        if (GetExtCallParam(pd->lParam, 1) == DLLA_EXPLORER_GOTOPATH)
        {
          char *pPath=NULL;

          if (IsExtCallParamValid(pd->lParam, 2))
            pPath=(char *)GetExtCallParam(pd->lParam, 2);

          if (pPath)
          {
            if (hWndBrowseTree) SearchTreeViewA(hWndBrowseTree, pPath);
          }
        }
      }
      else
      {
        if (GetExtCallParam(pd->lParam, 1) == DLLA_EXPLORER_GOTOPATH)
        {
          wchar_t *wpPath=NULL;

          if (IsExtCallParamValid(pd->lParam, 2))
            wpPath=(wchar_t *)GetExtCallParam(pd->lParam, 2);

          if (wpPath)
          {
            if (hWndBrowseTree) SearchTreeViewW(hWndBrowseTree, wpPath);
          }
        }
      }
      if (GetExtCallParam(pd->lParam, 1) == DLLA_EXPLORER_REFRESH)
      {
        if (hWndMainDlg) PostMessage(hWndMainDlg, AKDLL_REFRESH, 0, 0);
      }
    }

    //If plugin already loaded, stay in memory
    if (pd->bInMemory) pd->nUnload=UD_NONUNLOAD_ACTIVE;
  }
}

void CreateDock(HWND *hWndDock, DOCK **dkDock)
{
  DOCK dk={0};

  *hWndDock=NULL;
  dk.dwFlags=DKF_DRAGDROP;
  dk.nSide=nDockSide;
  dk.rcSize=rcDockRect;

  if (*dkDock=(DOCK *)SendMessage(hMainWnd, AKD_DOCK, DK_ADD, (LPARAM)&dk))
  {
    if (bOldWindows)
      *hWndDock=CreateDialogA(hInstanceDLL, MAKEINTRESOURCEA(IDD_EXPLORER), hMainWnd, (DLGPROC)MainDlgProcA);
    else
      *hWndDock=CreateDialogW(hInstanceDLL, MAKEINTRESOURCEW(IDD_EXPLORER), hMainWnd, (DLGPROC)MainDlgProcW);

    if (*hWndDock)
    {
      if (!(*dkDock)->rcSize.right || !(*dkDock)->rcSize.bottom)
      {
        GetWindowRect(*hWndDock, &(*dkDock)->rcSize);
        (*dkDock)->rcSize.right-=(*dkDock)->rcSize.left;
        (*dkDock)->rcSize.bottom-=(*dkDock)->rcSize.top;
        (*dkDock)->rcSize.left=0;
        (*dkDock)->rcSize.top=0;
      }
      (*dkDock)->hWnd=*hWndDock;
      SendMessage(hMainWnd, AKD_DOCK, DK_SUBCLASS, (LPARAM)*dkDock);

      if (!bDockWaitResize)
      {
        SendMessage(hMainWnd, AKD_RESIZE, 0, 0);
        ShowWindow(*hWndDock, SW_SHOW);
      }
    }
  }
}

void DestroyDock(HWND hWndDock, DWORD dwType)
{
  SendMessage(hWndDock, WM_COMMAND, IDC_CLOSE, dwType);
}

BOOL CALLBACK MainDlgProcA(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  static HWND hWndTitleText;
  static HWND hWndTitleClose;
  static HWND hWndBrowsePath;
  static LPCONTEXTMENU2 pExplorerSubMenu2;
  static LPCONTEXTMENU3 pExplorerSubMenu3;
  static DIALOGRESIZE drs[]={{&hWndTitleText,    DRS_SIZE|DRS_X},
                             {&hWndTitleClose,   DRS_MOVE|DRS_X},
                             {&hWndBrowseTree,   DRS_SIZE|DRS_X|DRS_Y},
                             {&hWndBrowsePath,   DRS_SIZE|DRS_X},
                             {0, 0}};

  if (uMsg == WM_INITDIALOG)
  {
    hWndBrowsePath=GetDlgItem(hDlg, IDC_BROWSE_PATH);
    hWndBrowseTree=GetDlgItem(hDlg, IDC_BROWSE_TREE);
    hWndTitleText=GetDlgItem(hDlg, IDC_TITLETEXT);
    hWndTitleClose=GetDlgItem(hDlg, IDC_CLOSE);

    hMenuLabel=CreatePopupMenu();
    AppendMenuA(hMenuLabel, MF_STRING, IDM_FINDDOCUMENT, GetLangStringA(wLangSystem, STRID_FINDDOCUMENT));
    AppendMenuA(hMenuLabel, MF_STRING, IDM_REFRESH, GetLangStringA(wLangSystem, STRID_REFRESH));
    AppendMenuA(hMenuLabel, MF_SEPARATOR, 0, NULL);
    AppendMenuA(hMenuLabel, MF_STRING, IDM_SETUP, GetLangStringA(wLangSystem, STRID_SETUP));

    SetWindowTextA(hWndTitleText, szPluginName);
    SendMessage(hMainWnd, AKD_SETCLOSEBUTTON, (WPARAM)hWndTitleClose, (LPARAM)NULL);

    if (!bOnMainStart) SendMessage(hDlg, AKDLL_INIT, 0, 0);
  }
  else if (uMsg == AKDLL_INIT)
  {
    //Enable images
    {
      HIMAGELIST hImageList;
      SHFILEINFOA sfi;

      hImageList=(HIMAGELIST)SHGetFileInfoAPtr("C:\\", 0, &sfi, sizeof(SHFILEINFOA), SHGFI_SYSICONINDEX|SHGFI_SMALLICON);
      if (hImageList) SendMessage(hWndBrowseTree, TVM_SETIMAGELIST, (WPARAM)TVSIL_NORMAL, (LPARAM)hImageList);
    }
    PopulateTreeA(hWndBrowseTree, nRootSpecial, szRootDirectory);
  }
  else if (uMsg == AKDLL_SETUP)
  {
    DialogBoxA(hInstanceDLL, MAKEINTRESOURCEA(IDD_SETUP), hDlg, (DLGPROC)SetupDlgProcA);
  }
  else if (uMsg == AKDLL_FINDDOCUMENT)
  {
    EDITINFO ei;

    if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
    {
      if (*(char *)ei.pFile)
      {
        SearchTreeViewA(hWndBrowseTree, (char *)ei.pFile);
      }
    }
  }
  else if (uMsg == AKDLL_REFRESH)
  {
    char szPath[MAX_PATH];
    HTREEITEM hSelItem;

    //Remember non-parent item
    if (hSelItem=(HTREEITEM)SendMessage(hWndBrowseTree, TVM_GETNEXTITEM, TVGN_CARET, (LPARAM)NULL))
    {
      if (SendMessage(hWndBrowseTree, TVM_GETNEXTITEM, TVGN_PARENT, (LPARAM)hSelItem))
      {
        GetSelItemTreeViewA(hWndBrowseTree, szPath);
      }
      else hSelItem=NULL;
    }
    PopulateTreeA(hWndBrowseTree, nRootSpecial, szRootDirectory);
    SetWindowTextA(hWndBrowsePath, "");

    //Restore non-parent item
    if (hSelItem) SearchTreeViewA(hWndBrowseTree, szPath);
  }
  else if (uMsg == WM_NOTIFY)
  {
    if (wParam == IDC_BROWSE_TREE)
    {
      if (((NMTREEVIEW *)lParam)->hdr.code == TVN_ITEMEXPANDINGA)
      {
        NMTREEVIEW *pnmtv=(NMTREEVIEW *)lParam;
        LPTVITEMDATA lptvid;
        LPSHELLFOLDER psfRoot=NULL;
        TVSORTCB tvscb;
        HRESULT hr;

        if (!(pnmtv->itemNew.state & TVIS_EXPANDEDONCE))
        {
          if (lptvid=(LPTVITEMDATA)pnmtv->itemNew.lParam)
          {
            hr=lptvid->psfParent->BindToObject(lptvid->pidlItem, 0, IID_IShellFolder, (void **)&psfRoot);

            if (SUCCEEDED(hr))
            {
              FillTreeViewA(hWndBrowseTree, psfRoot, lptvid->pidlRoot, pnmtv->itemNew.hItem);

              tvscb.hParent=pnmtv->itemNew.hItem;
              tvscb.lParam=0;
              tvscb.lpfnCompare=TreeViewCompareProc;
              SendMessage(hWndBrowseTree, TVM_SORTCHILDRENCB, 0, (LPARAM)&tvscb);

              psfRoot->Release();
            }
          }
        }
        else SendMessage(hWndBrowseTree, TVM_EXPAND, TVE_COLLAPSE|TVE_COLLAPSERESET, (LPARAM)pnmtv->itemNew.hItem);
      }
      else if (((NMTREEVIEW *)lParam)->hdr.code == TVN_SELCHANGEDA)
      {
        NMTREEVIEW *pnmtv=(NMTREEVIEW *)lParam;
        char szPath[MAX_PATH]="";
        LPTVITEMDATA lptvid;

        if (lptvid=(LPTVITEMDATA)pnmtv->itemNew.lParam)
        {
          SHGetPathFromIDListAPrt(lptvid->pidlRoot, szPath);
        }
        SetWindowTextA(hWndBrowsePath, szPath);
      }
      else if (((NMTREEVIEW *)lParam)->hdr.code == TVN_DELETEITEMA)
      {
        NMTREEVIEW *pnmtv=(NMTREEVIEW *)lParam;
	LPTVITEMDATA lptvid;
	LPMALLOC lpMalloc;

	if (SHGetMalloc(&lpMalloc) == NOERROR)
        {
          if (lptvid=(LPTVITEMDATA)pnmtv->itemOld.lParam)
          {
            lptvid->psfParent->Release();
            lpMalloc->Free(lptvid->pidlRoot);
            lpMalloc->Free(lptvid->pidlItem);
            lpMalloc->Free(lptvid);
          }
          lpMalloc->Release();
        }
      }
      else if (((NMTREEVIEW *)lParam)->hdr.code == TVN_KEYDOWN)
      {
        NMTVKEYDOWN *pnmtvkd=(NMTVKEYDOWN *)lParam;

        if (pnmtvkd->wVKey == VK_DELETE)
        {
          char szPath[MAX_PATH];
          HTREEITEM hSelItem;

          if (hSelItem=GetSelItemTreeViewA(hWndBrowseTree, szPath))
          {
            SHFILEOPSTRUCTA shfos;

            szPath[lstrlenA(szPath) + 1]='\0';
            shfos.hwnd=hDlg;
            shfos.wFunc=FO_DELETE;
            shfos.pFrom=szPath;
            shfos.pTo=NULL;
            shfos.fFlags=(GetKeyState(VK_SHIFT) >= 0)?FOF_ALLOWUNDO:0;

            if (!SHFileOperationAPtr(&shfos))
            {
              if (!shfos.fAnyOperationsAborted)
                SendMessage(hWndBrowseTree, TVM_DELETEITEM, 0, (LPARAM)hSelItem);
            }
          }
        }
        else if (pnmtvkd->wVKey == VK_F3)
        {
          PostMessage(hDlg, AKDLL_FINDDOCUMENT, 0, 0);
        }
        else if (pnmtvkd->wVKey == VK_F5)
        {
          PostMessage(hDlg, AKDLL_REFRESH, 0, 0);
        }
      }
      else if ((int)((NMHDR *)lParam)->code == NM_DBLCLK)
      {
        char szPath[MAX_PATH];

        if (GetSelItemTreeViewA(hWndBrowseTree, szPath))
        {
          TrimTrailBackSlashA(szPath);

          if (!(GetFileAttributesA(szPath) & FILE_ATTRIBUTE_DIRECTORY))
          {
            OpenDocumentA(szPath);
            SetFocus(hWndBrowseTree);
          }
        }
      }
    }
  }
  else if (uMsg == WM_LBUTTONDBLCLK)
  {
    POINT pt;
    RECT rc;

    GetCursorPos(&pt);
    GetWindowRect(hWndTitleText, &rc);

    if (PtInRect(&rc, pt))
    {
      PostMessage(hDlg, AKDLL_SETUP, 0, 0);
    }
  }
  else if (uMsg == WM_CONTEXTMENU)
  {
    if ((HWND)wParam == hDlg)
    {
      POINT pt;
      RECT rc;

      GetCursorPos(&pt);
      GetWindowRect(hWndTitleText, &rc);

      if (PtInRect(&rc, pt))
      {
        int nCmd;

        nCmd=TrackPopupMenu(hMenuLabel, TPM_RETURNCMD|TPM_NONOTIFY|TPM_LEFTBUTTON|TPM_RIGHTBUTTON, pt.x, pt.y, 0, hWndTitleText, NULL);

        if (nCmd == IDM_FINDDOCUMENT)
          PostMessage(hDlg, AKDLL_FINDDOCUMENT, 0, 0);
        else if (nCmd == IDM_REFRESH)
          PostMessage(hDlg, AKDLL_REFRESH, 0, 0);
        else if (nCmd == IDM_SETUP)
          PostMessage(hDlg, AKDLL_SETUP, 0, 0);
      }
    }
    else if ((HWND)wParam == hWndBrowseTree)
    {
      TVHITTESTINFO tvhti;
      TVITEMA tvi;
      LPTVITEMDATA lptvid;
      POINT ptScreen;
      int nCmd;

      GetCursorPos(&ptScreen);
      tvhti.pt=ptScreen;
      ScreenToClient(hWndBrowseTree, &tvhti.pt);
      SendMessage(hWndBrowseTree, TVM_HITTEST, 0, (LPARAM)&tvhti);

      if ((tvhti.flags & TVHT_ONITEMLABEL) || (tvhti.flags & TVHT_ONITEMICON))
      {
        SendMessage(hWndBrowseTree, TVM_SELECTITEM, TVGN_CARET, (LPARAM)tvhti.hItem);

        tvi.mask=TVIF_PARAM;
        tvi.hItem=tvhti.hItem;

        if (SendMessage(hWndBrowseTree, TVM_GETITEMA, 0, (LPARAM)&tvi))
        {
          if (lptvid=(LPTVITEMDATA)tvi.lParam)
          {
            LPCONTEXTMENU pcm;
            HMENU hMenu;
            HRESULT hr;

            hr=lptvid->psfParent->GetUIObjectOf(hDlg, 1, (LPCITEMIDLIST *)&lptvid->pidlItem, IID_IContextMenu, 0, (void **)&pcm);

            if (SUCCEEDED(hr))
            {
              pcm->QueryInterface(IID_IContextMenu2, (void **)&pExplorerSubMenu2);
              pcm->QueryInterface(IID_IContextMenu3, (void **)&pExplorerSubMenu3);

              if (hMenu=CreatePopupMenu())
              {
                hr=pcm->QueryContextMenu(hMenu, 0, 1, 0x7fff, CMF_EXPLORE);

                if (SUCCEEDED(hr))
                {
                  nCmd=TrackPopupMenu(hMenu, TPM_RETURNCMD|TPM_LEFTBUTTON|TPM_RIGHTBUTTON, ptScreen.x, ptScreen.y, 0, hDlg, NULL);

                  if (nCmd)
                  {
                    CMINVOKECOMMANDINFO ici={0};
                    char szPath[MAX_PATH];

                    ici.cbSize=sizeof(CMINVOKECOMMANDINFO);
                    ici.hwnd=hDlg;
                    ici.lpVerb=MAKEINTRESOURCEA(nCmd - 1);
                    ici.nShow=SW_SHOWNORMAL;

                    if (pcm->InvokeCommand(&ici) == NOERROR)
                    {
                      if (SHGetPathFromIDListAPrt(lptvid->pidlRoot, szPath))
                      {
                        TrimTrailBackSlashA(szPath);

                        if (GetFileAttributesA(szPath) == 0xFFFFFFFF)
                        {
                          SendMessage(hWndBrowseTree, TVM_DELETEITEM, 0, (LPARAM)tvhti.hItem);
                        }
                      }
                    }
                  }
                }
                DestroyMenu(hMenu);
              }
              if (pExplorerSubMenu3) pExplorerSubMenu3=NULL;
              if (pExplorerSubMenu2) pExplorerSubMenu2=NULL;
              pcm->Release();
            }
          }
        }
      }
      else
      {
        nCmd=TrackPopupMenu(hMenuLabel, TPM_RETURNCMD|TPM_NONOTIFY|TPM_LEFTBUTTON|TPM_RIGHTBUTTON, ptScreen.x, ptScreen.y, 0, hDlg, NULL);

        if (nCmd == IDM_FINDDOCUMENT)
          PostMessage(hDlg, AKDLL_FINDDOCUMENT, 0, 0);
        else if (nCmd == IDM_REFRESH)
          PostMessage(hDlg, AKDLL_REFRESH, 0, 0);
        else if (nCmd == IDM_SETUP)
          PostMessage(hDlg, AKDLL_SETUP, 0, 0);
      }
    }
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDOK)
    {
      HWND hWndFocus=GetFocus();

      if (hWndFocus == hWndBrowsePath)
      {
        char szPath[MAX_PATH];

        if (GetWindowTextA(hWndBrowsePath, szPath, MAX_PATH))
        {
          SearchTreeViewA(hWndBrowseTree, szPath);
        }
      }
      else if (hWndFocus == hWndBrowseTree)
      {
        NMHDR nmh={hDlg, IDC_BROWSE_TREE, NM_DBLCLK};

        SendMessage(hDlg, WM_NOTIFY, IDC_BROWSE_TREE, (LPARAM)&nmh);
      }
    }
    else if (LOWORD(wParam) == IDC_CLOSE ||
             LOWORD(wParam) == IDCANCEL)
    {
      if (bMainDialogRectSave || dkMainDlg->nSide != nDockSide)
        SaveOptionsA(OF_WINDOWRECT);

      if (lParam != DKT_NOUNLOAD)
      {
        UninitMain();
      }
      SendMessage(hMainWnd, AKD_DOCK, DK_DELETE, (LPARAM)dkMainDlg);
      dkMainDlg=NULL;

      DestroyMenu(hMenuLabel);
      DestroyWindow(hWndMainDlg);
      hWndMainDlg=NULL;
      hWndBrowseTree=NULL;

      if (lParam != DKT_ONMAINFINISH)
      {
        SendMessage(hMainWnd, AKD_RESIZE, 0, 0);
        SetFocus(hMainWnd);
        if (lParam != DKT_NOUNLOAD)
          PostMessage(hMainWnd, AKD_DLLUNLOAD, (WPARAM)hInstanceDLL, (LPARAM)NULL);
      }
    }
  }
  else if (uMsg == WM_CLOSE)
  {
    PostMessage(hDlg, WM_COMMAND, IDCANCEL, 0);
    return TRUE;
  }

  //Explorer menu
  if (pExplorerSubMenu3)
  {
    LRESULT lResult;

    if (SUCCEEDED(pExplorerSubMenu3->HandleMenuMsg2(uMsg, wParam, lParam, &lResult)))
      return lResult;
  }
  else if (pExplorerSubMenu2)
  {
    if (SUCCEEDED(pExplorerSubMenu2->HandleMenuMsg(uMsg, wParam, lParam)))
      return 0;
  }
  if (DialogResizeMessages(&drs[0], &rcMainInitDialog, &rcMainCurrentDialog, hDlg, uMsg, wParam, lParam))
  {
    if (IsWindowVisible(hDlg)) bMainDialogRectSave=TRUE;
    if (dkMainDlg) GetWindowPos(hWndTitleText, hDlg, &dkMainDlg->rcDragDrop);
  }

  return FALSE;
}

BOOL CALLBACK MainDlgProcW(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  static HWND hWndTitleText;
  static HWND hWndTitleClose;
  static HWND hWndBrowsePath;
  static LPCONTEXTMENU2 pExplorerSubMenu2;
  static LPCONTEXTMENU3 pExplorerSubMenu3;
  static DIALOGRESIZE drs[]={{&hWndTitleText,    DRS_SIZE|DRS_X},
                             {&hWndTitleClose,   DRS_MOVE|DRS_X},
                             {&hWndBrowseTree,   DRS_SIZE|DRS_X|DRS_Y},
                             {&hWndBrowsePath,   DRS_SIZE|DRS_X},
                             {0, 0}};

  if (uMsg == WM_INITDIALOG)
  {
    hWndBrowsePath=GetDlgItem(hDlg, IDC_BROWSE_PATH);
    hWndBrowseTree=GetDlgItem(hDlg, IDC_BROWSE_TREE);
    hWndTitleText=GetDlgItem(hDlg, IDC_TITLETEXT);
    hWndTitleClose=GetDlgItem(hDlg, IDC_CLOSE);

    hMenuLabel=CreatePopupMenu();
    AppendMenuW(hMenuLabel, MF_STRING, IDM_FINDDOCUMENT, GetLangStringW(wLangSystem, STRID_FINDDOCUMENT));
    AppendMenuW(hMenuLabel, MF_STRING, IDM_REFRESH, GetLangStringW(wLangSystem, STRID_REFRESH));
    AppendMenuW(hMenuLabel, MF_SEPARATOR, 0, NULL);
    AppendMenuW(hMenuLabel, MF_STRING, IDM_SETUP, GetLangStringW(wLangSystem, STRID_SETUP));

    SetWindowTextW(hWndTitleText, wszPluginName);
    SendMessage(hMainWnd, AKD_SETCLOSEBUTTON, (WPARAM)hWndTitleClose, (LPARAM)NULL);

    if (!bOnMainStart) SendMessage(hDlg, AKDLL_INIT, 0, 0);
  }
  else if (uMsg == AKDLL_INIT)
  {
    //Enable images
    {
      HIMAGELIST hImageList;
      SHFILEINFOW sfi;

      hImageList=(HIMAGELIST)SHGetFileInfoWPtr(L"C:\\", 0, &sfi, sizeof(SHFILEINFOW), SHGFI_SYSICONINDEX|SHGFI_SMALLICON);
      if (hImageList) SendMessage(hWndBrowseTree, TVM_SETIMAGELIST, (WPARAM)TVSIL_NORMAL, (LPARAM)hImageList);
    }
    PopulateTreeW(hWndBrowseTree, nRootSpecial, wszRootDirectory);
  }
  else if (uMsg == AKDLL_SETUP)
  {
    DialogBoxW(hInstanceDLL, MAKEINTRESOURCEW(IDD_SETUP), hDlg, (DLGPROC)SetupDlgProcW);
  }
  else if (uMsg == AKDLL_FINDDOCUMENT)
  {
    EDITINFO ei;

    if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
    {
      if (*(wchar_t *)ei.pFile)
      {
        SearchTreeViewW(hWndBrowseTree, (wchar_t *)ei.pFile);
      }
    }
  }
  else if (uMsg == AKDLL_REFRESH)
  {
    wchar_t wszPath[MAX_PATH];
    HTREEITEM hSelItem;

    //Remember non-parent item
    if (hSelItem=(HTREEITEM)SendMessage(hWndBrowseTree, TVM_GETNEXTITEM, TVGN_CARET, (LPARAM)NULL))
    {
      if (SendMessage(hWndBrowseTree, TVM_GETNEXTITEM, TVGN_PARENT, (LPARAM)hSelItem))
      {
        GetSelItemTreeViewW(hWndBrowseTree, wszPath);
      }
      else hSelItem=NULL;
    }
    PopulateTreeW(hWndBrowseTree, nRootSpecial, wszRootDirectory);
    SetWindowTextW(hWndBrowsePath, L"");

    //Restore non-parent item
    if (hSelItem) SearchTreeViewW(hWndBrowseTree, wszPath);
  }
  else if (uMsg == WM_NOTIFY)
  {
    if (wParam == IDC_BROWSE_TREE)
    {
      if (((NMTREEVIEW *)lParam)->hdr.code == TVN_ITEMEXPANDINGW)
      {
        NMTREEVIEW *pnmtv=(NMTREEVIEW *)lParam;
        LPTVITEMDATA lptvid;
        LPSHELLFOLDER psfRoot=NULL;
        TVSORTCB tvscb;
        HRESULT hr;

        if (!(pnmtv->itemNew.state & TVIS_EXPANDEDONCE))
        {
          if (lptvid=(LPTVITEMDATA)pnmtv->itemNew.lParam)
          {
            hr=lptvid->psfParent->BindToObject(lptvid->pidlItem, 0, IID_IShellFolder, (void **)&psfRoot);

            if (SUCCEEDED(hr))
            {
              FillTreeViewW(hWndBrowseTree, psfRoot, lptvid->pidlRoot, pnmtv->itemNew.hItem);

              tvscb.hParent=pnmtv->itemNew.hItem;
              tvscb.lParam=0;
              tvscb.lpfnCompare=TreeViewCompareProc;
              SendMessage(hWndBrowseTree, TVM_SORTCHILDRENCB, 0, (LPARAM)&tvscb);

              psfRoot->Release();
            }
          }
        }
        else SendMessage(hWndBrowseTree, TVM_EXPAND, TVE_COLLAPSE|TVE_COLLAPSERESET, (LPARAM)pnmtv->itemNew.hItem);
      }
      else if (((NMTREEVIEW *)lParam)->hdr.code == TVN_SELCHANGEDW)
      {
        NMTREEVIEW *pnmtv=(NMTREEVIEW *)lParam;
        wchar_t wszPath[MAX_PATH]=L"";
        LPTVITEMDATA lptvid;

        if (lptvid=(LPTVITEMDATA)pnmtv->itemNew.lParam)
        {
          SHGetPathFromIDListWPrt(lptvid->pidlRoot, wszPath);
        }
        SetWindowTextW(hWndBrowsePath, wszPath);
      }
      else if (((NMTREEVIEW *)lParam)->hdr.code == TVN_DELETEITEMW)
      {
        NMTREEVIEW *pnmtv=(NMTREEVIEW *)lParam;
	LPTVITEMDATA lptvid;
	LPMALLOC lpMalloc;

	if (SHGetMalloc(&lpMalloc) == NOERROR)
        {
          if (lptvid=(LPTVITEMDATA)pnmtv->itemOld.lParam)
          {
            lptvid->psfParent->Release();
            lpMalloc->Free(lptvid->pidlRoot);
            lpMalloc->Free(lptvid->pidlItem);
            lpMalloc->Free(lptvid);
          }
          lpMalloc->Release();
        }
      }
      else if (((NMTREEVIEW *)lParam)->hdr.code == TVN_KEYDOWN)
      {
        NMTVKEYDOWN *pnmtvkd=(NMTVKEYDOWN *)lParam;

        if (pnmtvkd->wVKey == VK_DELETE)
        {
          wchar_t wszPath[MAX_PATH];
          HTREEITEM hSelItem;

          if (hSelItem=GetSelItemTreeViewW(hWndBrowseTree, wszPath))
          {
            SHFILEOPSTRUCTW shfos;

            wszPath[lstrlenW(wszPath) + 1]='\0';
            shfos.hwnd=hDlg;
            shfos.wFunc=FO_DELETE;
            shfos.pFrom=wszPath;
            shfos.pTo=NULL;
            shfos.fFlags=(GetKeyState(VK_SHIFT) >= 0)?FOF_ALLOWUNDO:0;

            if (!SHFileOperationWPtr(&shfos))
            {
              if (!shfos.fAnyOperationsAborted)
                SendMessage(hWndBrowseTree, TVM_DELETEITEM, 0, (LPARAM)hSelItem);
            }
          }
        }
        else if (pnmtvkd->wVKey == VK_F3)
        {
          PostMessage(hDlg, AKDLL_FINDDOCUMENT, 0, 0);
        }
        else if (pnmtvkd->wVKey == VK_F5)
        {
          PostMessage(hDlg, AKDLL_REFRESH, 0, 0);
        }
      }
      else if ((int)((NMHDR *)lParam)->code == NM_DBLCLK)
      {
        wchar_t wszPath[MAX_PATH];

        if (GetSelItemTreeViewW(hWndBrowseTree, wszPath))
        {
          TrimTrailBackSlashW(wszPath);

          if (!(GetFileAttributesW(wszPath) & FILE_ATTRIBUTE_DIRECTORY))
          {
            OpenDocumentW(wszPath);
            SetFocus(hWndBrowseTree);
          }
        }
      }
    }
  }
  else if (uMsg == WM_LBUTTONDBLCLK)
  {
    POINT pt;
    RECT rc;

    GetCursorPos(&pt);
    GetWindowRect(hWndTitleText, &rc);

    if (PtInRect(&rc, pt))
    {
      PostMessage(hDlg, AKDLL_SETUP, 0, 0);
    }
  }
  else if (uMsg == WM_CONTEXTMENU)
  {
    if ((HWND)wParam == hDlg)
    {
      POINT pt;
      RECT rc;

      GetCursorPos(&pt);
      GetWindowRect(hWndTitleText, &rc);

      if (PtInRect(&rc, pt))
      {
        int nCmd;

        nCmd=TrackPopupMenu(hMenuLabel, TPM_RETURNCMD|TPM_NONOTIFY|TPM_LEFTBUTTON|TPM_RIGHTBUTTON, pt.x, pt.y, 0, hWndTitleText, NULL);

        if (nCmd == IDM_FINDDOCUMENT)
          PostMessage(hDlg, AKDLL_FINDDOCUMENT, 0, 0);
        else if (nCmd == IDM_REFRESH)
          PostMessage(hDlg, AKDLL_REFRESH, 0, 0);
        else if (nCmd == IDM_SETUP)
          PostMessage(hDlg, AKDLL_SETUP, 0, 0);
      }
    }
    else if ((HWND)wParam == hWndBrowseTree)
    {
      TVHITTESTINFO tvhti;
      TVITEMW tvi;
      LPTVITEMDATA lptvid;
      POINT ptScreen;
      int nCmd;

      GetCursorPos(&ptScreen);
      tvhti.pt=ptScreen;
      ScreenToClient(hWndBrowseTree, &tvhti.pt);
      SendMessage(hWndBrowseTree, TVM_HITTEST, 0, (LPARAM)&tvhti);

      if ((tvhti.flags & TVHT_ONITEMLABEL) || (tvhti.flags & TVHT_ONITEMICON))
      {
        SendMessage(hWndBrowseTree, TVM_SELECTITEM, TVGN_CARET, (LPARAM)tvhti.hItem);

        tvi.mask=TVIF_PARAM;
        tvi.hItem=tvhti.hItem;

        if (SendMessage(hWndBrowseTree, TVM_GETITEMW, 0, (LPARAM)&tvi))
        {
          if (lptvid=(LPTVITEMDATA)tvi.lParam)
          {
            LPCONTEXTMENU pcm;
            HMENU hMenu;
            HRESULT hr;

            hr=lptvid->psfParent->GetUIObjectOf(hDlg, 1, (LPCITEMIDLIST *)&lptvid->pidlItem, IID_IContextMenu, 0, (void **)&pcm);

            if (SUCCEEDED(hr))
            {
              pcm->QueryInterface(IID_IContextMenu2, (void **)&pExplorerSubMenu2);
              pcm->QueryInterface(IID_IContextMenu3, (void **)&pExplorerSubMenu3);

              if (hMenu=CreatePopupMenu())
              {
                hr=pcm->QueryContextMenu(hMenu, 0, 1, 0x7fff, CMF_EXPLORE);

                if (SUCCEEDED(hr))
                {
                  nCmd=TrackPopupMenu(hMenu, TPM_RETURNCMD|TPM_LEFTBUTTON|TPM_RIGHTBUTTON, ptScreen.x, ptScreen.y, 0, hDlg, NULL);

                  if (nCmd)
                  {
                    CMINVOKECOMMANDINFO ici={0};
                    wchar_t wszPath[MAX_PATH];

                    ici.cbSize=sizeof(CMINVOKECOMMANDINFO);
                    ici.hwnd=hDlg;
                    ici.lpVerb=MAKEINTRESOURCEA(nCmd - 1);
                    ici.nShow=SW_SHOWNORMAL;

                    if (pcm->InvokeCommand(&ici) == NOERROR)
                    {
                      if (SHGetPathFromIDListWPrt(lptvid->pidlRoot, wszPath))
                      {
                        TrimTrailBackSlashW(wszPath);

                        if (GetFileAttributesW(wszPath) == 0xFFFFFFFF)
                        {
                          SendMessage(hWndBrowseTree, TVM_DELETEITEM, 0, (LPARAM)tvhti.hItem);
                        }
                      }
                    }
                  }
                }
                DestroyMenu(hMenu);
              }
              if (pExplorerSubMenu3) pExplorerSubMenu3=NULL;
              if (pExplorerSubMenu2) pExplorerSubMenu2=NULL;
              pcm->Release();
            }
          }
        }
      }
      else
      {
        nCmd=TrackPopupMenu(hMenuLabel, TPM_RETURNCMD|TPM_NONOTIFY|TPM_LEFTBUTTON|TPM_RIGHTBUTTON, ptScreen.x, ptScreen.y, 0, hDlg, NULL);

        if (nCmd == IDM_FINDDOCUMENT)
          PostMessage(hDlg, AKDLL_FINDDOCUMENT, 0, 0);
        else if (nCmd == IDM_REFRESH)
          PostMessage(hDlg, AKDLL_REFRESH, 0, 0);
        else if (nCmd == IDM_SETUP)
          PostMessage(hDlg, AKDLL_SETUP, 0, 0);
      }
    }
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDOK)
    {
      HWND hWndFocus=GetFocus();

      if (hWndFocus == hWndBrowsePath)
      {
        wchar_t wszPath[MAX_PATH];

        if (GetWindowTextW(hWndBrowsePath, wszPath, MAX_PATH))
        {
          SearchTreeViewW(hWndBrowseTree, wszPath);
        }
      }
      else if (hWndFocus == hWndBrowseTree)
      {
        NMHDR nmh={hDlg, IDC_BROWSE_TREE, NM_DBLCLK};

        SendMessage(hDlg, WM_NOTIFY, IDC_BROWSE_TREE, (LPARAM)&nmh);
      }
    }
    else if (LOWORD(wParam) == IDC_CLOSE ||
             LOWORD(wParam) == IDCANCEL)
    {
      if (bMainDialogRectSave || dkMainDlg->nSide != nDockSide)
        SaveOptionsW(OF_WINDOWRECT);

      if (lParam != DKT_NOUNLOAD)
      {
        UninitMain();
      }
      SendMessage(hMainWnd, AKD_DOCK, DK_DELETE, (LPARAM)dkMainDlg);
      dkMainDlg=NULL;

      DestroyMenu(hMenuLabel);
      DestroyWindow(hWndMainDlg);
      hWndMainDlg=NULL;
      hWndBrowseTree=NULL;

      if (lParam != DKT_ONMAINFINISH)
      {
        SendMessage(hMainWnd, AKD_RESIZE, 0, 0);
        SetFocus(hMainWnd);
        if (lParam != DKT_NOUNLOAD)
          PostMessage(hMainWnd, AKD_DLLUNLOAD, (WPARAM)hInstanceDLL, (LPARAM)NULL);
      }
    }
  }
  else if (uMsg == WM_CLOSE)
  {
    PostMessage(hDlg, WM_COMMAND, IDCANCEL, 0);
    return TRUE;
  }

  //Explorer menu
  if (pExplorerSubMenu3)
  {
    LRESULT lResult;

    if (SUCCEEDED(pExplorerSubMenu3->HandleMenuMsg2(uMsg, wParam, lParam, &lResult)))
      return lResult;
  }
  else if (pExplorerSubMenu2)
  {
    if (SUCCEEDED(pExplorerSubMenu2->HandleMenuMsg(uMsg, wParam, lParam)))
      return 0;
  }
  if (DialogResizeMessages(&drs[0], &rcMainInitDialog, &rcMainCurrentDialog, hDlg, uMsg, wParam, lParam))
  {
    if (IsWindowVisible(hDlg)) bMainDialogRectSave=TRUE;
    if (dkMainDlg) GetWindowPos(hWndTitleText, hDlg, &dkMainDlg->rcDragDrop);
  }

  return FALSE;
}

BOOL DialogResizeMessages(DIALOGRESIZE *drs, RECT *rcInit, RECT *rcCurrent, HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  if (uMsg == WM_INITDIALOG)
  {
    RECT rcTemplate;

    GetWindowPos(hDlg, NULL, rcInit);
    rcTemplate=*rcCurrent;
    *rcCurrent=*rcInit;

    if (rcTemplate.right && rcTemplate.bottom)
    {
      rcTemplate.left=rcInit->left + (rcInit->right - rcTemplate.right) / 2;
      rcTemplate.top=rcInit->top + (rcInit->bottom - rcTemplate.bottom) / 2;
      SetWindowPos(hDlg, 0, rcTemplate.left, rcTemplate.top, rcTemplate.right, rcTemplate.bottom, SWP_NOZORDER);
    }
  }
  else if (uMsg == WM_GETMINMAXINFO)
  {
    //MINMAXINFO *mmi=(MINMAXINFO *)lParam;
    //
    //mmi->ptMinTrackSize.x=rcInit->right;
    //mmi->ptMinTrackSize.y=rcInit->bottom;
  }
  else if (uMsg == WM_SIZE)
  {
    if (lParam)
    {
      RECT rcTemplate;
      RECT rcControl;
      DWORD dwFlags;
      POINT pt;
      int i;

      GetWindowPos(hDlg, NULL, &rcTemplate);
      pt.x=rcTemplate.right - rcCurrent->right;
      pt.y=rcTemplate.bottom - rcCurrent->bottom;
      *rcCurrent=rcTemplate;

      for (i=0; drs[i].lpWnd; ++i)
      {
        if (*drs[i].lpWnd)
        {
          dwFlags=0;
          if (drs[i].dwType & DRS_SIZE)
            dwFlags|=SWP_NOMOVE;
          else if (drs[i].dwType & DRS_MOVE)
            dwFlags|=SWP_NOSIZE;
          GetWindowPos(*drs[i].lpWnd, hDlg, &rcControl);
          SetWindowPos(*drs[i].lpWnd, 0, rcControl.left + ((drs[i].dwType & DRS_X)?pt.x:0), rcControl.top + ((drs[i].dwType & DRS_Y)?pt.y:0), rcControl.right + ((drs[i].dwType & DRS_X)?pt.x:0), rcControl.bottom + ((drs[i].dwType & DRS_Y)?pt.y:0), dwFlags|SWP_NOZORDER);
        }
      }
      InvalidateRect(hDlg, NULL, TRUE);
      return TRUE;
    }
  }
  else if (uMsg == WM_PAINT)
  {
    //PAINTSTRUCT ps;
    //RECT rcGrip;
    //HDC hDC;
    //
    //if (hDC=BeginPaint(hDlg, &ps))
    //{
    //  GetClientRect(hDlg, &rcGrip);
    //  rcGrip.left=rcGrip.right - GetSystemMetrics(SM_CXVSCROLL);
    //  rcGrip.top=rcGrip.bottom - GetSystemMetrics(SM_CYVSCROLL);
    //  DrawFrameControl(hDC, &rcGrip, DFC_SCROLL, DFCS_SCROLLSIZEGRIP);
    //  EndPaint(hDlg, &ps);
    //}
  }
  return FALSE;
}

BOOL GetWindowPos(HWND hWnd, HWND hWndOwner, RECT *rc)
{
  if (GetWindowRect(hWnd, rc))
  {
    rc->right-=rc->left;
    rc->bottom-=rc->top;

    if (hWndOwner)
    {
      if (!ScreenToClient(hWndOwner, (POINT *)&rc->left))
        return FALSE;
    }
    return TRUE;
  }
  return FALSE;
}

BOOL CALLBACK SetupDlgProcA(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  static HICON hPluginIcon;
  static HWND hWndRootDirectory;
  static HWND hWndRootMyComputer;
  static HWND hWndShowHidden;

  if (uMsg == WM_INITDIALOG)
  {
    hPluginIcon=LoadIconA(hInstanceDLL, MAKEINTRESOURCEA(IDI_ICON));
    SendMessage(hDlg, WM_SETICON, (WPARAM)ICON_BIG, (LPARAM)hPluginIcon);
    hWndRootDirectory=GetDlgItem(hDlg, IDC_SETUP_ROOT_DIRECTORY);
    hWndRootMyComputer=GetDlgItem(hDlg, IDC_SETUP_ROOT_MYCOMPUTER);
    hWndShowHidden=GetDlgItem(hDlg, IDC_SETUP_SHOWHIDDEN);

    SetDlgItemTextA(hDlg, IDC_SETUP_ROOT_GROUP, GetLangStringA(wLangSystem, STRID_ROOTDIRECTORY));
    SetDlgItemTextA(hDlg, IDC_SETUP_ROOT_MYCOMPUTER, GetLangStringA(wLangSystem, STRID_MYCOMPUTER));
    SetDlgItemTextA(hDlg, IDC_SETUP_SHOWHIDDEN, GetLangStringA(wLangSystem, STRID_SHOWHIDDEN));
    SetDlgItemTextA(hDlg, IDOK, GetLangStringA(wLangSystem, STRID_OK));
    SetDlgItemTextA(hDlg, IDCANCEL, GetLangStringA(wLangSystem, STRID_CANCEL));

    SendMessage(hWndRootDirectory, EM_LIMITTEXT, (WPARAM)MAX_PATH, 0);
    SetWindowTextA(hWndRootDirectory, szRootDirectory);
    if (nRootSpecial) SendMessage(hWndRootMyComputer, BM_SETCHECK, BST_CHECKED, 0);
    if (bShowHidden) SendMessage(hWndShowHidden, BM_SETCHECK, BST_CHECKED, 0);

    SendMessage(hDlg, WM_COMMAND, IDC_SETUP_ROOT_MYCOMPUTER, 0);
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDC_SETUP_ROOT_MYCOMPUTER)
    {
      if (SendMessage(hWndRootMyComputer, BM_GETCHECK, 0, 0) == BST_CHECKED)
        EnableWindow(hWndRootDirectory, FALSE);
      else
        EnableWindow(hWndRootDirectory, TRUE);
    }
    else if (LOWORD(wParam) == IDOK)
    {
      GetWindowTextA(hWndRootDirectory, szRootDirectory, MAX_PATH);
      if (SendMessage(hWndRootMyComputer, BM_GETCHECK, 0, 0) == BST_CHECKED)
        nRootSpecial=CSIDL_DRIVES;
      else
        nRootSpecial=CSIDL_DESKTOP;
      bShowHidden=SendMessage(hWndShowHidden, BM_GETCHECK, 0, 0);

      SaveOptionsA(OF_SETTINGS);

      EndDialog(hDlg, 0);
      PostMessage(hWndMainDlg, AKDLL_REFRESH, 0, 0);
      return TRUE;
    }
    else if (LOWORD(wParam) == IDCANCEL)
    {
      EndDialog(hDlg, 0);
      return TRUE;
    }
  }
  else if (uMsg == WM_CLOSE)
  {
    PostMessage(hDlg, WM_COMMAND, IDCANCEL, 0);
    return TRUE;
  }
  else if (uMsg == WM_DESTROY)
  {
    DestroyIcon(hPluginIcon);
  }
  return FALSE;
}

BOOL CALLBACK SetupDlgProcW(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  static HICON hPluginIcon;
  static HWND hWndRootDirectory;
  static HWND hWndRootMyComputer;
  static HWND hWndShowHidden;

  if (uMsg == WM_INITDIALOG)
  {
    hPluginIcon=LoadIconW(hInstanceDLL, MAKEINTRESOURCEW(IDI_ICON));
    SendMessage(hDlg, WM_SETICON, (WPARAM)ICON_BIG, (LPARAM)hPluginIcon);
    hWndRootDirectory=GetDlgItem(hDlg, IDC_SETUP_ROOT_DIRECTORY);
    hWndRootMyComputer=GetDlgItem(hDlg, IDC_SETUP_ROOT_MYCOMPUTER);
    hWndShowHidden=GetDlgItem(hDlg, IDC_SETUP_SHOWHIDDEN);

    SetDlgItemTextW(hDlg, IDC_SETUP_ROOT_GROUP, GetLangStringW(wLangSystem, STRID_ROOTDIRECTORY));
    SetDlgItemTextW(hDlg, IDC_SETUP_ROOT_MYCOMPUTER, GetLangStringW(wLangSystem, STRID_MYCOMPUTER));
    SetDlgItemTextW(hDlg, IDC_SETUP_SHOWHIDDEN, GetLangStringW(wLangSystem, STRID_SHOWHIDDEN));
    SetDlgItemTextW(hDlg, IDOK, GetLangStringW(wLangSystem, STRID_OK));
    SetDlgItemTextW(hDlg, IDCANCEL, GetLangStringW(wLangSystem, STRID_CANCEL));

    SendMessage(hWndRootDirectory, EM_LIMITTEXT, (WPARAM)MAX_PATH, 0);
    SetWindowTextW(hWndRootDirectory, wszRootDirectory);
    if (nRootSpecial) SendMessage(hWndRootMyComputer, BM_SETCHECK, BST_CHECKED, 0);
    if (bShowHidden) SendMessage(hWndShowHidden, BM_SETCHECK, BST_CHECKED, 0);

    SendMessage(hDlg, WM_COMMAND, IDC_SETUP_ROOT_MYCOMPUTER, 0);
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDC_SETUP_ROOT_MYCOMPUTER)
    {
      if (SendMessage(hWndRootMyComputer, BM_GETCHECK, 0, 0) == BST_CHECKED)
        EnableWindow(hWndRootDirectory, FALSE);
      else
        EnableWindow(hWndRootDirectory, TRUE);
    }
    else if (LOWORD(wParam) == IDOK)
    {
      GetWindowTextW(hWndRootDirectory, wszRootDirectory, MAX_PATH);
      if (SendMessage(hWndRootMyComputer, BM_GETCHECK, 0, 0) == BST_CHECKED)
        nRootSpecial=CSIDL_DRIVES;
      else
        nRootSpecial=CSIDL_DESKTOP;
      bShowHidden=SendMessage(hWndShowHidden, BM_GETCHECK, 0, 0);

      SaveOptionsW(OF_SETTINGS);

      EndDialog(hDlg, 0);
      PostMessage(hWndMainDlg, AKDLL_REFRESH, 0, 0);
      return TRUE;
    }
    else if (LOWORD(wParam) == IDCANCEL)
    {
      EndDialog(hDlg, 0);
      return TRUE;
    }
  }
  else if (uMsg == WM_CLOSE)
  {
    PostMessage(hDlg, WM_COMMAND, IDCANCEL, 0);
    return TRUE;
  }
  else if (uMsg == WM_DESTROY)
  {
    DestroyIcon(hPluginIcon);
  }
  return FALSE;
}

LRESULT CALLBACK NewMainProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  if (uMsg == AKDN_MAIN_ONSTART_IDLE)
  {
    if (bOnMainStart) PostMessage(hWndMainDlg, AKDLL_INIT, 0, 0);
  }
  else if (uMsg == AKDN_SIZE)
  {
    if (bDockWaitResize)
    {
      bDockWaitResize=FALSE;
      ShowWindow(hWndMainDlg, SW_SHOW);
    }
  }
  else if (uMsg == AKDN_MAIN_ONFINISH)
  {
    NewMainProcData->NextProc(hWnd, uMsg, wParam, lParam);

    if (hWndMainDlg)
    {
      DestroyDock(hWndMainDlg, DKT_ONMAINFINISH);
    }
    return FALSE;
  }

  //Call next procedure
  return NewMainProcData->NextProc(hWnd, uMsg, wParam, lParam);
}

void PopulateTreeA(HWND hWnd, int nRootSpecial, char *pRootDirectory)
{
  LPSHELLFOLDER psfDesktopFolder=NULL;
  LPSHELLFOLDER psfFolder=NULL;
  LPSHELLFOLDER psfRoot=NULL;
  LPITEMIDLIST pidlFolder=NULL;
  LPMALLOC pMalloc=NULL;
  TVSORTCB tvscb;
  wchar_t wszRoot[MAX_PATH];

  if (SHGetDesktopFolder(&psfDesktopFolder) == NOERROR)
  {
    if (nRootSpecial)
    {
      if (SHGetSpecialFolderLocation(hWnd, nRootSpecial, &pidlFolder) == S_OK)
      {
        psfDesktopFolder->BindToObject(pidlFolder, NULL, IID_IShellFolder, (void **)&psfFolder);
        psfRoot=psfFolder;
      }
    }
    else if (*pRootDirectory)
    {
      MultiByteToWideChar(CP_ACP, 0, pRootDirectory, -1, wszRoot, MAX_PATH);

      if (psfDesktopFolder->ParseDisplayName(hWnd, NULL, wszRoot, NULL, &pidlFolder, NULL) == S_OK)
      {
        psfDesktopFolder->BindToObject(pidlFolder, NULL, IID_IShellFolder, (void **)&psfFolder);
        psfRoot=psfFolder;
      }
    }
    else psfRoot=psfDesktopFolder;

    if (psfRoot)
    {
      SendMessage(hWnd, TVM_DELETEITEM, 0, (LPARAM)TVI_ROOT);
      FillTreeViewA(hWnd, psfRoot, pidlFolder, TVI_ROOT);

      tvscb.hParent=TVI_ROOT;
      tvscb.lParam=0;
      tvscb.lpfnCompare=TreeViewCompareProc;
      SendMessage(hWnd, TVM_SORTCHILDRENCB, 0, (LPARAM)&tvscb);

      if (SHGetMalloc(&pMalloc) == NOERROR)
      {
        pMalloc->Free(pidlFolder);
        pMalloc->Release();
      }
      if (psfFolder) psfFolder->Release();
    }
    psfDesktopFolder->Release();
  }
}

void PopulateTreeW(HWND hWnd, int nRootSpecial, wchar_t *wpRootDirectory)
{
  LPSHELLFOLDER psfDesktopFolder=NULL;
  LPSHELLFOLDER psfFolder=NULL;
  LPSHELLFOLDER psfRoot=NULL;
  LPITEMIDLIST pidlFolder=NULL;
  LPMALLOC pMalloc=NULL;
  TVSORTCB tvscb;

  if (SHGetDesktopFolder(&psfDesktopFolder) == NOERROR)
  {
    SendMessage(hWnd, TVM_DELETEITEM, 0, (LPARAM)TVI_ROOT);

    if (nRootSpecial)
    {
      if (SHGetSpecialFolderLocation(hWnd, nRootSpecial, &pidlFolder) == S_OK)
      {
        psfDesktopFolder->BindToObject(pidlFolder, NULL, IID_IShellFolder, (void **)&psfFolder);
        psfRoot=psfFolder;
      }
    }
    else if (*wpRootDirectory)
    {
      if (psfDesktopFolder->ParseDisplayName(hWnd, NULL, wpRootDirectory, NULL, &pidlFolder, NULL) == S_OK)
      {
        psfDesktopFolder->BindToObject(pidlFolder, NULL, IID_IShellFolder, (void **)&psfFolder);
        psfRoot=psfFolder;
      }
    }
    else psfRoot=psfDesktopFolder;

    if (psfRoot)
    {
      FillTreeViewW(hWnd, psfRoot, pidlFolder, TVI_ROOT);

      tvscb.hParent=TVI_ROOT;
      tvscb.lParam=0;
      tvscb.lpfnCompare=TreeViewCompareProc;
      SendMessage(hWnd, TVM_SORTCHILDRENCB, 0, (LPARAM)&tvscb);

      if (SHGetMalloc(&pMalloc) == NOERROR)
      {
        pMalloc->Free(pidlFolder);
        pMalloc->Release();
      }
      if (psfFolder) psfFolder->Release();
    }
    psfDesktopFolder->Release();
  }
}

void FillTreeViewA(HWND hWnd, LPSHELLFOLDER psfRoot, LPITEMIDLIST pidlRoot, HTREEITEM hParent)
{
  char szName[MAX_PATH];
  char szPath[MAX_PATH];
  HWND hWndParent;
  LPENUMIDLIST pedl=NULL;
  LPITEMIDLIST pidlEnum=NULL;
  LPTVITEMDATA lptvid=NULL;
  LPMALLOC lpMalloc=NULL;
  ULONG ulFetched;
  ULONG ulAttrs;
  ULONG ulState;
  TVINSERTSTRUCTA tvis;
  TVITEMA tvi;
  HTREEITEM hPrev=NULL;

  hWndParent=GetParent(hWnd);

  if (SHGetMalloc(&lpMalloc) == NOERROR)
  {
    if (psfRoot->EnumObjects(hWndParent, SHCONTF_FOLDERS|SHCONTF_NONFOLDERS|(bShowHidden?SHCONTF_INCLUDEHIDDEN:0), &pedl) == S_OK)
    {
      while (pedl->Next(1, &pidlEnum, &ulFetched) == S_OK)
      {
        ulAttrs=SFGAO_FOLDER|SFGAO_FILESYSTEM|SFGAO_SHARE|SFGAO_LINK|SFGAO_GHOSTED;

        if (psfRoot->GetAttributesOf(1, (LPCITEMIDLIST *)&pidlEnum, &ulAttrs) == S_OK)
        {
          if (lptvid=(LPTVITEMDATA)lpMalloc->Alloc(sizeof(TVITEMDATA)))
          {
            if (GetItemNameA(psfRoot, pidlEnum, SHGDN_NORMAL, szName, MAX_PATH))
            {
              lptvid->psfParent=psfRoot;
              psfRoot->AddRef();
              lptvid->pidlRoot=ConcatPIDL(pidlRoot, pidlEnum);
              lptvid->pidlItem=CopyPIDL(pidlEnum);

              ulState=0;
              if (ulAttrs & SFGAO_SHARE)
                ulState|=INDEXTOOVERLAYMASK(1);
              if (ulAttrs & SFGAO_LINK)
                ulState|=INDEXTOOVERLAYMASK(2);
              if (ulAttrs & SFGAO_GHOSTED)
                ulState|=TVIS_CUT;

              tvi.mask=TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE|TVIF_PARAM|TVIF_STATE;
              tvi.state=ulState;
              tvi.stateMask=TVIS_OVERLAYMASK|TVIS_CUT;
              tvi.pszText=szName;
              tvi.cchTextMax=MAX_PATH;
              tvi.iImage=GetItemIconA(lptvid->pidlRoot, SHGFI_PIDL|SHGFI_SYSICONINDEX|SHGFI_SMALLICON);
              tvi.iSelectedImage=GetItemIconA(lptvid->pidlRoot, SHGFI_PIDL|SHGFI_SYSICONINDEX|SHGFI_SMALLICON|SHGFI_OPENICON);
              tvi.lParam=(LPARAM)lptvid;

              if (ulAttrs & SFGAO_FOLDER)
              {
                if (!(ulAttrs & SFGAO_STREAM)) //not .zip
                {
                  if (!(ulAttrs & SFGAO_FILESYSTEM))
                  {
                    tvi.cChildren=1;
                    tvi.mask|=TVIF_CHILDREN;
                  }
                  else
                  {
                    if (SHGetPathFromIDListAPrt(lptvid->pidlRoot, szPath))
                    {
                      TrimTrailBackSlashA(szPath);

                      if (szPath[lstrlenA(szPath) - 1] == ':' || !IsDirEmptyA(szPath))
                      {
                        tvi.cChildren=1;
                        tvi.mask|=TVIF_CHILDREN;
                      }
                    }
                  }
                }
              }

              tvis.item=tvi;
              tvis.hInsertAfter=hPrev;
              tvis.hParent=hParent;
              hPrev=(HTREEITEM)SendMessage(hWnd, TVM_INSERTITEMA, 0, (LPARAM)&tvis);
            }
          }
          else break;
        }
        lpMalloc->Free(pidlEnum);
        pidlEnum=NULL;
      }
      if (pidlEnum) lpMalloc->Free(pidlEnum);
      pedl->Release();
    }
    lpMalloc->Release();
  }
}

void FillTreeViewW(HWND hWnd, LPSHELLFOLDER psfRoot, LPITEMIDLIST pidlRoot, HTREEITEM hParent)
{
  wchar_t wszName[MAX_PATH];
  wchar_t wszPath[MAX_PATH];
  HWND hWndParent;
  LPENUMIDLIST pedl=NULL;
  LPITEMIDLIST pidlEnum=NULL;
  LPTVITEMDATA lptvid=NULL;
  LPMALLOC lpMalloc=NULL;
  ULONG ulFetched;
  ULONG ulAttrs;
  ULONG ulState;
  TVINSERTSTRUCTW tvis;
  TVITEMW tvi;
  HTREEITEM hPrev=NULL;

  hWndParent=GetParent(hWnd);

  if (SHGetMalloc(&lpMalloc) == NOERROR)
  {
    if (psfRoot->EnumObjects(hWndParent, SHCONTF_FOLDERS|SHCONTF_NONFOLDERS|(bShowHidden?SHCONTF_INCLUDEHIDDEN:0), &pedl) == S_OK)
    {
      while (pedl->Next(1, &pidlEnum, &ulFetched) == S_OK)
      {
        ulAttrs=SFGAO_FOLDER|SFGAO_FILESYSTEM|SFGAO_SHARE|SFGAO_LINK|SFGAO_GHOSTED;

        if (psfRoot->GetAttributesOf(1, (LPCITEMIDLIST *)&pidlEnum, &ulAttrs) == S_OK)
        {
          if (lptvid=(LPTVITEMDATA)lpMalloc->Alloc(sizeof(TVITEMDATA)))
          {
            if (GetItemNameW(psfRoot, pidlEnum, SHGDN_NORMAL, wszName, MAX_PATH))
            {
              lptvid->psfParent=psfRoot;
              psfRoot->AddRef();
              lptvid->pidlRoot=ConcatPIDL(pidlRoot, pidlEnum);
              lptvid->pidlItem=CopyPIDL(pidlEnum);

              ulState=0;
              if (ulAttrs & SFGAO_SHARE)
                ulState|=INDEXTOOVERLAYMASK(1);
              if (ulAttrs & SFGAO_LINK)
                ulState|=INDEXTOOVERLAYMASK(2);
              if (ulAttrs & SFGAO_GHOSTED)
                ulState|=TVIS_CUT;

              tvi.mask=TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE|TVIF_PARAM|TVIF_STATE;
              tvi.state=ulState;
              tvi.stateMask=TVIS_OVERLAYMASK|TVIS_CUT;
              tvi.pszText=wszName;
              tvi.cchTextMax=MAX_PATH;
              tvi.iImage=GetItemIconW(lptvid->pidlRoot, SHGFI_PIDL|SHGFI_SYSICONINDEX|SHGFI_SMALLICON);
              tvi.iSelectedImage=GetItemIconW(lptvid->pidlRoot, SHGFI_PIDL|SHGFI_SYSICONINDEX|SHGFI_SMALLICON|SHGFI_OPENICON);
              tvi.lParam=(LPARAM)lptvid;

              if (ulAttrs & SFGAO_FOLDER)
              {
                if (!(ulAttrs & SFGAO_STREAM)) //not .zip
                {
                  if (!(ulAttrs & SFGAO_FILESYSTEM))
                  {
                    tvi.cChildren=1;
                    tvi.mask|=TVIF_CHILDREN;
                  }
                  else
                  {
                    if (SHGetPathFromIDListWPrt(lptvid->pidlRoot, wszPath))
                    {
                      TrimTrailBackSlashW(wszPath);

                      if (wszPath[lstrlenW(wszPath) - 1] == ':' || !IsDirEmptyW(wszPath))
                      {
                        tvi.cChildren=1;
                        tvi.mask|=TVIF_CHILDREN;
                      }
                    }
                  }
                }
              }

              tvis.item=tvi;
              tvis.hInsertAfter=hPrev;
              tvis.hParent=hParent;
              hPrev=(HTREEITEM)SendMessage(hWnd, TVM_INSERTITEMW, 0, (LPARAM)&tvis);
            }
          }
          else break;
        }
        lpMalloc->Free(pidlEnum);
        pidlEnum=NULL;
      }
      if (pidlEnum) lpMalloc->Free(pidlEnum);
      pedl->Release();
    }
    lpMalloc->Release();
  }
}

void SearchTreeViewA(HWND hWnd, char *pPath)
{
  LPSHELLFOLDER pDesktopFolder=NULL;
  LPITEMIDLIST pidlInitial;
  LPITEMIDLIST pidlNext;
  LPITEMIDLIST pidlTemp;
  LPTVITEMDATA lptvid;
  HTREEITEM hNextItem;
  HTREEITEM hSelItem=NULL;
  LPMALLOC pMalloc=NULL;
  TVITEMA tvi;
  wchar_t wszPath[MAX_PATH];
  BOOL bRoot=TRUE;

  if (SHGetDesktopFolder(&pDesktopFolder) == NOERROR)
  {
    MultiByteToWideChar(CP_ACP, 0, pPath, -1, wszPath, MAX_PATH);

    if (pDesktopFolder->ParseDisplayName(hWnd, NULL, wszPath, NULL, &pidlInitial, NULL) == S_OK)
    {
      pidlNext=pidlInitial;
      hNextItem=(HTREEITEM)SendMessage(hWnd, TVM_GETNEXTITEM, TVGN_ROOT, (LPARAM)NULL);

      while (pidlNext->mkid.cb && hNextItem)
      {
        tvi.mask=TVIF_PARAM;
        tvi.hItem=hNextItem;

        if (SendMessage(hWnd, TVM_GETITEMA, 0, (LPARAM)&tvi))
        {
          if (lptvid=(LPTVITEMDATA)tvi.lParam)
          {
            if ((bRoot && (pidlTemp=ComparePIDL(pidlNext, lptvid->pidlRoot))) ||
                (!bRoot && CompareITEMID(pidlNext, lptvid->pidlItem)))
            {
              if (bRoot)
              {
                pidlNext=pidlTemp;
                bRoot=FALSE;
              }
              else pidlNext=NextPIDL(pidlNext);

              SendMessage(hWnd, TVM_EXPAND, TVE_EXPAND, (LPARAM)hNextItem);
              hSelItem=hNextItem;
              hNextItem=(HTREEITEM)SendMessage(hWnd, TVM_GETNEXTITEM, TVGN_CHILD, (LPARAM)hNextItem);
              continue;
            }
          }
        }
        hNextItem=(HTREEITEM)SendMessage(hWnd, TVM_GETNEXTITEM, TVGN_NEXT, (LPARAM)hNextItem);
      }
      if (hSelItem)
      {
        SendMessage(hWnd, TVM_SELECTITEM, TVGN_CARET, (LPARAM)hSelItem);
        SendMessage(hWnd, TVM_ENSUREVISIBLE, 0, (LPARAM)hSelItem);
//        SendMessage(hWnd, TVM_SELECTITEM, TVGN_FIRSTVISIBLE, (LPARAM)hSelItem);
      }
      if (SHGetMalloc(&pMalloc) == NOERROR)
      {
        pMalloc->Free(pidlInitial);
        pMalloc->Release();
      }
    }
    pDesktopFolder->Release();
  }
}

void SearchTreeViewW(HWND hWnd, wchar_t *wpPath)
{
  LPSHELLFOLDER pDesktopFolder=NULL;
  LPITEMIDLIST pidlInitial;
  LPITEMIDLIST pidlNext;
  LPITEMIDLIST pidlTemp;
  LPTVITEMDATA lptvid;
  HTREEITEM hNextItem;
  HTREEITEM hSelItem=NULL;
  LPMALLOC pMalloc=NULL;
  TVITEMW tvi;
  BOOL bRoot=TRUE;

  if (SHGetDesktopFolder(&pDesktopFolder) == NOERROR)
  {
    if (pDesktopFolder->ParseDisplayName(hWnd, NULL, wpPath, NULL, &pidlInitial, NULL) == S_OK)
    {
      pidlNext=pidlInitial;
      hNextItem=(HTREEITEM)SendMessage(hWnd, TVM_GETNEXTITEM, TVGN_ROOT, (LPARAM)NULL);

      while (pidlNext->mkid.cb && hNextItem)
      {
        tvi.mask=TVIF_PARAM;
        tvi.hItem=hNextItem;

        if (SendMessage(hWnd, TVM_GETITEMW, 0, (LPARAM)&tvi))
        {
          if (lptvid=(LPTVITEMDATA)tvi.lParam)
          {
            if ((bRoot && (pidlTemp=ComparePIDL(pidlNext, lptvid->pidlRoot))) ||
                (!bRoot && CompareITEMID(pidlNext, lptvid->pidlItem)))
            {
              if (bRoot)
              {
                pidlNext=pidlTemp;
                bRoot=FALSE;
              }
              else pidlNext=NextPIDL(pidlNext);

              SendMessage(hWnd, TVM_EXPAND, TVE_EXPAND, (LPARAM)hNextItem);
              hSelItem=hNextItem;
              hNextItem=(HTREEITEM)SendMessage(hWnd, TVM_GETNEXTITEM, TVGN_CHILD, (LPARAM)hNextItem);
              continue;
            }
          }
        }
        hNextItem=(HTREEITEM)SendMessage(hWnd, TVM_GETNEXTITEM, TVGN_NEXT, (LPARAM)hNextItem);
      }
      if (hSelItem)
      {
        SendMessage(hWnd, TVM_SELECTITEM, TVGN_CARET, (LPARAM)hSelItem);
        SendMessage(hWnd, TVM_ENSUREVISIBLE, 0, (LPARAM)hSelItem);
//        SendMessage(hWnd, TVM_SELECTITEM, TVGN_FIRSTVISIBLE, (LPARAM)hSelItem);
      }
      if (SHGetMalloc(&pMalloc) == NOERROR)
      {
        pMalloc->Free(pidlInitial);
        pMalloc->Release();
      }
    }
    pDesktopFolder->Release();
  }
}

HTREEITEM GetSelItemTreeViewA(HWND hWnd, char *szPath)
{
  LPTVITEMDATA lptvid;
  TVITEMA tvi;
  HTREEITEM hSelItem;

  if (hSelItem=(HTREEITEM)SendMessage(hWnd, TVM_GETNEXTITEM, TVGN_CARET, (LPARAM)NULL))
  {
    tvi.mask=TVIF_PARAM;
    tvi.hItem=hSelItem;

    if (SendMessage(hWnd, TVM_GETITEMA, 0, (LPARAM)&tvi))
    {
      if (lptvid=(LPTVITEMDATA)tvi.lParam)
      {
        if (SHGetPathFromIDListAPrt(lptvid->pidlRoot, szPath))
        {
          return hSelItem;
        }
      }
    }
  }
  return NULL;
}

HTREEITEM GetSelItemTreeViewW(HWND hWnd, wchar_t *wszPath)
{
  LPTVITEMDATA lptvid;
  TVITEMW tvi;
  HTREEITEM hSelItem;

  if (hSelItem=(HTREEITEM)SendMessage(hWndBrowseTree, TVM_GETNEXTITEM, TVGN_CARET, (LPARAM)NULL))
  {
    tvi.mask=TVIF_PARAM;
    tvi.hItem=hSelItem;

    if (SendMessage(hWndBrowseTree, TVM_GETITEMW, 0, (LPARAM)&tvi))
    {
      if (lptvid=(LPTVITEMDATA)tvi.lParam)
      {
        if (SHGetPathFromIDListWPrt(lptvid->pidlRoot, wszPath))
        {
          return hSelItem;
        }
      }
    }
  }
  return NULL;
}

int CALLBACK TreeViewCompareProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
  LPTVITEMDATA lptvid1=(LPTVITEMDATA)lParam1;
  LPTVITEMDATA lptvid2=(LPTVITEMDATA)lParam2;
  HRESULT hr;

  hr=lptvid1->psfParent->CompareIDs(0, lptvid1->pidlItem, lptvid2->pidlItem);

  return (short)HRESULT_CODE(hr);
}

BOOL GetItemNameA(LPSHELLFOLDER psf, LPITEMIDLIST pidl, DWORD dwFlags, char *szName, int nMaxName)
{
  STRRET sr;
  BOOL bResult=TRUE;

  if (psf->GetDisplayNameOf(pidl, dwFlags, &sr) == NOERROR)
  {
    if (sr.uType == STRRET_WSTR)
    {
      WideCharToMultiByte(CP_ACP, 0, sr.pOleStr, -1, szName, nMaxName, NULL, NULL);
    }
    else if (sr.uType == STRRET_OFFSET)
    {
      lstrcpynA(szName, (char *)(((unsigned char *)pidl) + sr.uOffset), nMaxName);
    }
    else if (sr.uType == STRRET_CSTR)
    {
      lstrcpynA(szName, (char *)sr.cStr, nMaxName);
    }
    else bResult=FALSE;
  }
  else bResult=FALSE;

  return bResult;
}

BOOL GetItemNameW(LPSHELLFOLDER psf, LPITEMIDLIST pidl, DWORD dwFlags, wchar_t *wszName, int nMaxName)
{
  STRRET sr;
  BOOL bResult=TRUE;

  if (psf->GetDisplayNameOf(pidl, dwFlags, &sr) == NOERROR)
  {
    if (sr.uType == STRRET_WSTR)
    {
      lstrcpynW(wszName, sr.pOleStr, nMaxName);
    }
    else if (sr.uType == STRRET_OFFSET)
    {
      MultiByteToWideChar(CP_ACP, 0, (char *)(((unsigned char *)pidl) + sr.uOffset), -1, wszName, nMaxName);
    }
    else if (sr.uType == STRRET_CSTR)
    {
      MultiByteToWideChar(CP_ACP, 0, sr.cStr, -1, wszName, nMaxName);
    }
    else bResult=FALSE;
  }
  else bResult=FALSE;

  return bResult;
}

int GetItemIconA(LPITEMIDLIST pidl, UINT uFlags)
{
  SHFILEINFOA sfi;

  SHGetFileInfoAPtr((char *)pidl, 0, &sfi, sizeof(SHFILEINFOA), uFlags);

  return sfi.iIcon;
}

int GetItemIconW(LPITEMIDLIST pidl, UINT uFlags)
{
  SHFILEINFOW sfi;

  SHGetFileInfoWPtr((wchar_t *)pidl, 0, &sfi, sizeof(SHFILEINFOW), uFlags);

  return sfi.iIcon;
}

LPITEMIDLIST CreatePIDL(UINT cbSize)
{
  LPMALLOC lpMalloc=NULL;
  LPITEMIDLIST pidl=NULL;

  if (SHGetMalloc(&lpMalloc) == NOERROR)
  {
    if (pidl=(LPITEMIDLIST)lpMalloc->Alloc(cbSize))
    {
      memset(pidl, 0, cbSize);
    }
    lpMalloc->Release();
  }
  return pidl;
}

LPITEMIDLIST NextPIDL(LPCITEMIDLIST pidl)
{
  unsigned char *pMem=(unsigned char *)pidl;

  pMem+=pidl->mkid.cb;

  return (LPITEMIDLIST)pMem;
}

UINT GetSizePIDL(LPCITEMIDLIST pidl)
{
  UINT cbTotal=0;

  if (pidl)
  {
    cbTotal+=sizeof(pidl->mkid.cb);

    while (pidl->mkid.cb)
    {
      cbTotal+=pidl->mkid.cb;
      pidl=NextPIDL(pidl);
    }
  }
  return cbTotal;
}

LPITEMIDLIST CopyPIDL(LPCITEMIDLIST pidl)
{
  LPITEMIDLIST pidlNew;
  UINT cb;

  cb=GetSizePIDL(pidl);

  if (pidlNew=CreatePIDL(cb))
  {
    memcpy(pidlNew, pidl, cb);
  }
  return pidlNew;
}

LPITEMIDLIST ConcatPIDL(LPCITEMIDLIST pidl1, LPCITEMIDLIST pidl2)
{
  LPITEMIDLIST pidlNew;
  UINT cb1;
  UINT cb2;

  if (pidl1)
    cb1=GetSizePIDL(pidl1) - sizeof(pidl1->mkid.cb);
  else
    cb1=0;
  cb2=GetSizePIDL(pidl2);

  if (pidlNew=CreatePIDL(cb1 + cb2))
  {
    if (pidl1) memcpy(pidlNew, pidl1, cb1);
    memcpy(((unsigned char *)pidlNew) + cb1, pidl2, cb2);
  }
  return pidlNew;
}

BOOL CompareITEMID(LPCITEMIDLIST pidl1, LPCITEMIDLIST pidl2)
{
  if (pidl1->mkid.cb == pidl2->mkid.cb)
  {
    if (!memcmp(pidl1, pidl2, pidl1->mkid.cb))
    {
      return TRUE;
    }
  }
  return FALSE;
}

LPITEMIDLIST ComparePIDL(LPCITEMIDLIST pidlFull, LPCITEMIDLIST pidlPart)
{
  LPITEMIDLIST pidl1=(LPITEMIDLIST)pidlFull;
  LPITEMIDLIST pidl2=(LPITEMIDLIST)pidlPart;

  while (pidl1->mkid.cb && pidl2->mkid.cb)
  {
    if (CompareITEMID(pidl1, pidl2))
    {
      pidl1=NextPIDL(pidl1);
      pidl2=NextPIDL(pidl2);
    }
    else return NULL;
  }
  if (pidl2->mkid.cb)
    return NULL;
  return pidl1;
}

void OpenDocumentA(char *pFile)
{
  PMOPENDOCUMENTA *pmod;

  if (*pFile)
  {
    if (pmod=(PMOPENDOCUMENTA *)GlobalAlloc(GPTR, sizeof(PMOPENDOCUMENTA)))
    {
      pmod->od.hWnd=NULL;
      lstrcpynA(pmod->od.szFile, pFile, MAX_PATH);
      pmod->od.szWorkDir[0]='\0';
      pmod->od.dwFlags=OD_ADT_BINARY_ERROR|OD_ADT_REG_CODEPAGE;
      pmod->od.nCodePage=0;
      pmod->od.bBOM=0;

      pmod->cds.dwData=CD_OPENDOCUMENT;
      pmod->cds.cbData=sizeof(OPENDOCUMENTA);
      pmod->cds.lpData=&pmod->od;

      //Post message
      pmod->pm.hWnd=hMainWnd;
      pmod->pm.uMsg=WM_COPYDATA;
      pmod->pm.wParam=(WPARAM)hMainWnd;
      pmod->pm.lParam=(LPARAM)&pmod->cds;
      PostMessage(hMainWnd, AKD_POSTMESSAGE, 0, (LPARAM)pmod);
    }
  }
}

void OpenDocumentW(wchar_t *wpFile)
{
  PMOPENDOCUMENTW *pmod;

  if (*wpFile)
  {
    if (pmod=(PMOPENDOCUMENTW *)GlobalAlloc(GPTR, sizeof(PMOPENDOCUMENTW)))
    {
      pmod->od.hWnd=NULL;
      lstrcpynW(pmod->od.szFile, wpFile, MAX_PATH);
      pmod->od.szWorkDir[0]='\0';
      pmod->od.dwFlags=OD_ADT_BINARY_ERROR|OD_ADT_REG_CODEPAGE;
      pmod->od.nCodePage=0;
      pmod->od.bBOM=0;

      pmod->cds.dwData=CD_OPENDOCUMENT;
      pmod->cds.cbData=sizeof(OPENDOCUMENTW);
      pmod->cds.lpData=&pmod->od;

      //Post message
      pmod->pm.hWnd=hMainWnd;
      pmod->pm.uMsg=WM_COPYDATA;
      pmod->pm.wParam=(WPARAM)hMainWnd;
      pmod->pm.lParam=(LPARAM)&pmod->cds;
      PostMessage(hMainWnd, AKD_POSTMESSAGE, 0, (LPARAM)pmod);
    }
  }
}

BOOL IsDirEmptyA(char *pDir)
{
  char szMask[MAX_PATH];
  WIN32_FIND_DATAA wfd;
  HANDLE hSearch;
  BOOL bResult=TRUE;

  lstrcpynA(szMask, pDir, MAX_PATH - 5);
  lstrcatA(szMask, "\\*.*");

  if ((hSearch=FindFirstFileA(szMask, &wfd)) != INVALID_HANDLE_VALUE)
  {
    do
    {
      if (wfd.cFileName[0] == '.' && (wfd.cFileName[1] == '\0' || (wfd.cFileName[1] == '.' && wfd.cFileName[2] == '\0'))) continue;

      bResult=FALSE;
      break;
    }
    while (FindNextFileA(hSearch, &wfd));

    FindClose(hSearch);
  }
  return bResult;
}

BOOL IsDirEmptyW(wchar_t *wpDir)
{
  wchar_t wszMask[MAX_PATH];
  WIN32_FIND_DATAW wfd;
  HANDLE hSearch;
  BOOL bResult=TRUE;

  lstrcpynW(wszMask, wpDir, MAX_PATH - 5);
  lstrcatW(wszMask, L"\\*.*");

  if ((hSearch=FindFirstFileW(wszMask, &wfd)) != INVALID_HANDLE_VALUE)
  {
    do
    {
      if (wfd.cFileName[0] == '.' && (wfd.cFileName[1] == '\0' || (wfd.cFileName[1] == '.' && wfd.cFileName[2] == '\0'))) continue;

      bResult=FALSE;
      break;
    }
    while (FindNextFileW(hSearch, &wfd));

    FindClose(hSearch);
  }
  return bResult;
}

BOOL TrimTrailBackSlashA(char *szDir)
{
  int nLen;
  int i;

  nLen=lstrlenA(szDir);

  for (i=nLen - 1; i > 0 && szDir[i] == '\\'; --i)
  {
    szDir[i]='\0';
  }
  if (i < nLen - 1) return TRUE;
  return FALSE;
}

BOOL TrimTrailBackSlashW(wchar_t *wszDir)
{
  int nLen;
  int i;

  nLen=lstrlenW(wszDir);

  for (i=nLen - 1; i > 0 && wszDir[i] == '\\'; --i)
  {
    wszDir[i]='\0';
  }
  if (i < nLen - 1) return TRUE;
  return FALSE;
}


//// Options

void ReadOptionsA()
{
  PLUGINOPTIONA po;
  HANDLE hOptions;

  if (hOptions=(HANDLE)SendMessage(hMainWnd, AKD_BEGINOPTIONS, POB_READ, (LPARAM)szPluginName))
  {
    po.pOptionName="DockSide";
    po.dwType=PO_DWORD;
    po.lpData=(LPBYTE)&nDockSide;
    po.dwData=sizeof(DWORD);
    SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    po.pOptionName="DockRect";
    po.dwType=PO_BINARY;
    po.lpData=(LPBYTE)&rcDockRect;
    po.dwData=sizeof(RECT);
    SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    po.pOptionName="RootDirectory";
    po.dwType=PO_STRING;
    po.lpData=(LPBYTE)szRootDirectory;
    po.dwData=MAX_PATH;
    SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    po.pOptionName="RootSpecial";
    po.dwType=PO_DWORD;
    po.lpData=(LPBYTE)&nRootSpecial;
    po.dwData=sizeof(DWORD);
    SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    po.pOptionName="ShowHidden";
    po.dwType=PO_DWORD;
    po.lpData=(LPBYTE)&bShowHidden;
    po.dwData=sizeof(DWORD);
    SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    SendMessage(hMainWnd, AKD_ENDOPTIONS, (WPARAM)hOptions, 0);
  }
}

void ReadOptionsW()
{
  PLUGINOPTIONW po;
  HANDLE hOptions;

  if (hOptions=(HANDLE)SendMessage(hMainWnd, AKD_BEGINOPTIONS, POB_READ, (LPARAM)wszPluginName))
  {
    po.pOptionName=L"DockSide";
    po.dwType=PO_DWORD;
    po.lpData=(LPBYTE)&nDockSide;
    po.dwData=sizeof(DWORD);
    SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    po.pOptionName=L"DockRect";
    po.dwType=PO_BINARY;
    po.lpData=(LPBYTE)&rcDockRect;
    po.dwData=sizeof(RECT);
    SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    po.pOptionName=L"RootDirectory";
    po.dwType=PO_STRING;
    po.lpData=(LPBYTE)wszRootDirectory;
    po.dwData=MAX_PATH * sizeof(wchar_t);
    SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    po.pOptionName=L"RootSpecial";
    po.dwType=PO_DWORD;
    po.lpData=(LPBYTE)&nRootSpecial;
    po.dwData=sizeof(DWORD);
    SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    po.pOptionName=L"ShowHidden";
    po.dwType=PO_DWORD;
    po.lpData=(LPBYTE)&bShowHidden;
    po.dwData=sizeof(DWORD);
    SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    SendMessage(hMainWnd, AKD_ENDOPTIONS, (WPARAM)hOptions, 0);
  }
}

void SaveOptionsA(DWORD dwFlags)
{
  PLUGINOPTIONA po;
  HANDLE hOptions;

  if (hOptions=(HANDLE)SendMessage(hMainWnd, AKD_BEGINOPTIONS, POB_SAVE, (LPARAM)szPluginName))
  {
    if (dwFlags & OF_WINDOWRECT)
    {
      po.pOptionName="DockSide";
      po.dwType=PO_DWORD;
      po.lpData=(LPBYTE)&dkMainDlg->nSide;
      po.dwData=sizeof(DWORD);
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

      po.pOptionName="DockRect";
      po.dwType=PO_BINARY;
      po.lpData=(LPBYTE)&dkMainDlg->rcSize;
      po.dwData=sizeof(RECT);
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);
    }

    if (dwFlags & OF_SETTINGS)
    {
      po.pOptionName="RootDirectory";
      po.dwType=PO_STRING;
      po.lpData=(LPBYTE)szRootDirectory;
      po.dwData=lstrlenA(szRootDirectory) + 1;
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

      po.pOptionName="RootSpecial";
      po.dwType=PO_DWORD;
      po.lpData=(LPBYTE)&nRootSpecial;
      po.dwData=sizeof(DWORD);
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

      po.pOptionName="ShowHidden";
      po.dwType=PO_DWORD;
      po.lpData=(LPBYTE)&bShowHidden;
      po.dwData=sizeof(DWORD);
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);
    }

    SendMessage(hMainWnd, AKD_ENDOPTIONS, (WPARAM)hOptions, 0);
  }
}

void SaveOptionsW(DWORD dwFlags)
{
  PLUGINOPTIONW po;
  HANDLE hOptions;

  if (hOptions=(HANDLE)SendMessage(hMainWnd, AKD_BEGINOPTIONS, POB_SAVE, (LPARAM)wszPluginName))
  {
    if (dwFlags & OF_WINDOWRECT)
    {
      po.pOptionName=L"DockSide";
      po.dwType=PO_DWORD;
      po.lpData=(LPBYTE)&dkMainDlg->nSide;
      po.dwData=sizeof(DWORD);
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

      po.pOptionName=L"DockRect";
      po.dwType=PO_BINARY;
      po.lpData=(LPBYTE)&dkMainDlg->rcSize;
      po.dwData=sizeof(RECT);
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);
    }

    if (dwFlags & OF_SETTINGS)
    {
      po.pOptionName=L"RootDirectory";
      po.dwType=PO_STRING;
      po.lpData=(LPBYTE)wszRootDirectory;
      po.dwData=lstrlenW(wszRootDirectory) * sizeof(wchar_t) + 2;
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

      po.pOptionName=L"RootSpecial";
      po.dwType=PO_DWORD;
      po.lpData=(LPBYTE)&nRootSpecial;
      po.dwData=sizeof(DWORD);
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

      po.pOptionName=L"ShowHidden";
      po.dwType=PO_DWORD;
      po.lpData=(LPBYTE)&bShowHidden;
      po.dwData=sizeof(DWORD);
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);
    }

    SendMessage(hMainWnd, AKD_ENDOPTIONS, (WPARAM)hOptions, 0);
  }
}

char* GetLangStringA(LANGID wLangID, int nStringID)
{
  static char szStringBuf[MAX_PATH];

  WideCharToMultiByte(CP_ACP, 0, GetLangStringW(wLangID, nStringID), -1, szStringBuf, MAX_PATH, NULL, NULL);
  return szStringBuf;
}

wchar_t* GetLangStringW(LANGID wLangID, int nStringID)
{
  if (wLangID == LANG_RUSSIAN)
  {
    if (nStringID == STRID_SETUP)
      return L"\x041D\x0430\x0441\x0442\x0440\x043E\x0439\x043A\x0438\x002E\x002E\x002E";
    if (nStringID == STRID_FINDDOCUMENT)
      return L"\x041D\x0430\x0439\x0442\x0438\x0020\x0434\x043E\x043A\x0443\x043C\x0435\x043D\x0442\tF3";
    if (nStringID == STRID_REFRESH)
      return L"\x041E\x0431\x043D\x043E\x0432\x0438\x0442\x044C\tF5";
    if (nStringID == STRID_ROOTDIRECTORY)
      return L"\x041A\x043E\x0440\x043D\x0435\x0432\x043E\x0439\x0020\x043A\x0430\x0442\x0430\x043B\x043E\x0433";
    if (nStringID == STRID_MYCOMPUTER)
      return L"\x041C\x043E\x0439\x0020\x043A\x043E\x043C\x043F\x044C\x044E\x0442\x0435\x0440";
    if (nStringID == STRID_SHOWHIDDEN)
      return L"\x041F\x043E\x043A\x0430\x0437\x044B\x0432\x0430\x0442\x044C\x0020\x0441\x043A\x0440\x044B\x0442\x044B\x0435\x0020\x044D\x043B\x0435\x043C\x0435\x043D\x0442\x044B";
    if (nStringID == STRID_OK)
      return L"\x004F\x004B";
    if (nStringID == STRID_CANCEL)
      return L"\x041E\x0442\x043C\x0435\x043D\x0430";
  }
  else
  {
    if (nStringID == STRID_SETUP)
      return L"Settings...";
    if (nStringID == STRID_FINDDOCUMENT)
      return L"Find document\tF3";
    if (nStringID == STRID_REFRESH)
      return L"Refresh\tF5";
    if (nStringID == STRID_ROOTDIRECTORY)
      return L"Root directory";
    if (nStringID == STRID_MYCOMPUTER)
      return L"My Computer";
    if (nStringID == STRID_SHOWHIDDEN)
      return L"Show hidden items";
    if (nStringID == STRID_OK)
      return L"OK";
    if (nStringID == STRID_CANCEL)
      return L"Cancel";
  }
  return L"";
}

BOOL IsExtCallParamValid(LPARAM lParam, int nIndex)
{
  if (*((int *)lParam) >= (int)((nIndex + 1) * sizeof(int)))
    return TRUE;
  return FALSE;
}

int GetExtCallParam(LPARAM lParam, int nIndex)
{
  if (*((int *)lParam) >= (int)((nIndex + 1) * sizeof(int)))
    return *(((int *)lParam) + nIndex);
  return 0;
}

void InitCommon(PLUGINDATA *pd)
{
  bInitCommon=TRUE;
  hInstanceDLL=pd->hInstanceDLL;
  bOnMainStart=pd->bOnStart;
  hMainWnd=pd->hMainWnd;
  hWndEdit=pd->hWndEdit;
  bMDI=pd->bMDI;
  bOldWindows=pd->bOldWindows;
  wLangSystem=PRIMARYLANGID(pd->wLangSystem);

  if (bOldWindows)
  {
    int i;

    for (i=0; ((char *)pd->pFunction)[i] != ':'; ++i)
      szPluginName[i]=((char *)pd->pFunction)[i];
    szPluginName[i]='\0';
  }
  else
  {
    int i;

    for (i=0; ((wchar_t *)pd->pFunction)[i] != ':'; ++i)
      wszPluginName[i]=((wchar_t *)pd->pFunction)[i];
    wszPluginName[i]='\0';
  }

  if (bOldWindows)
  {
    HMODULE hShell32;

    hShell32=GetModuleHandleA("shell32.dll");
    SHFileOperationAPtr=(int (WINAPI *)(LPSHFILEOPSTRUCTA))GetProcAddress(hShell32, "SHFileOperationA");
    SHGetFileInfoAPtr=(DWORD (WINAPI *)(char *, DWORD, SHFILEINFOA *, UINT, UINT))GetProcAddress(hShell32, "SHGetFileInfoA");
    SHGetPathFromIDListAPrt=(BOOL (WINAPI *)(LPCITEMIDLIST, char *))GetProcAddress(hShell32, "SHGetPathFromIDListA");
    ReadOptionsA();
  }
  else
  {
    HMODULE hShell32;

    hShell32=GetModuleHandleW(L"shell32.dll");
    SHFileOperationWPtr=(int (WINAPI *)(LPSHFILEOPSTRUCTW))GetProcAddress(hShell32, "SHFileOperationW");
    SHGetFileInfoWPtr=(DWORD (WINAPI *)(wchar_t *, DWORD, SHFILEINFOW *, UINT, UINT))GetProcAddress(hShell32, "SHGetFileInfoW");
    SHGetPathFromIDListWPrt=(BOOL (WINAPI *)(LPCITEMIDLIST, wchar_t *))GetProcAddress(hShell32, "SHGetPathFromIDListW");
    ReadOptionsW();
  }
}

void InitMain()
{
  bInitMain=TRUE;

  //SubClass
  NewMainProcData=NULL;
  SendMessage(hMainWnd, AKD_SETMAINPROC, (WPARAM)NewMainProc, (LPARAM)&NewMainProcData);
}

void UninitMain()
{
  bInitMain=FALSE;

  //Remove subclass
  if (NewMainProcData)
  {
    SendMessage(hMainWnd, AKD_SETMAINPROC, (WPARAM)NULL, (LPARAM)&NewMainProcData);
    NewMainProcData=NULL;
  }
}

//Entry point
extern "C" BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
  if (fdwReason == DLL_PROCESS_ATTACH)
  {
  }
  else if (fdwReason == DLL_THREAD_ATTACH)
  {
  }
  else if (fdwReason == DLL_THREAD_DETACH)
  {
  }
  else if (fdwReason == DLL_PROCESS_DETACH)
  {
  }
  return TRUE;
}
